;;; ==============================================================
;;;                  Strom-Prozeduren 

(define  der-leere-strom '())
(define (cons-strom s1 s2) (cons s1 s2))
(define (kopf s) (car s))
(define (rest s) (cdr s))
(define (leerer-strom? s) (null? s))

(define (append-stroeme s1 s2)
  (if (leerer-strom? s1)
      s2
      (cons-strom (kopf s1)
		  (append-stroeme (rest s1) s2))))

(define (abb f liste)
  (if (leerer-strom? liste)
      der-leere-strom
      (cons-strom (f (kopf liste)) (abb f (rest liste)))))

(define (akk op e s)
  (if (leerer-strom? s)
      e
      (op (kopf s) (akk op e (rest s)))))

(define ( glaetten s)
  (akk append-stroeme der-leere-strom s))

(define (glattabb f s) (glaetten (abb f s)))


(define (filter p l)
  (if (leerer-strom? l)
       der-leere-strom
       (if (p (kopf l))
	   (cons-strom (kopf l) 
		       (filter p (rest l)))
	   (filter p (rest l)))))


;;;==============================================================
;;;    Prozeduren fuer das Damenproblem

(define (x-koord dame) (car dame))
(define (y-koord dame) (cdr dame))

(define leeres-brett (cons-strom der-leere-strom  der-leere-strom))
(define (hinzufuegen dame  damen) (cons-strom dame damen))

(define (bedroht? dame1 dame2)
  (or (= (x-koord dame1) (x-koord dame2))
      (= (y-koord dame1) (y-koord dame2))
      (= (abs (- (x-koord dame1) (x-koord dame2)))
	 (abs (- (y-koord dame1) (y-koord dame2))) )))

(define (unbedroht? dame damen)
  (if (leerer-strom? damen)
      #t
      (and (not (bedroht? dame (kopf damen)))
	   (unbedroht? dame (rest damen)))))
		
(define (zeilen max-zeilen)
  (define (durchzaehlen n)
    (if (= n 0)
	der-leere-strom
	(cons-strom n (durchzaehlen (- n 1)))))
  (durchzaehlen max-zeilen))

(define (damen spalten) 
 (define (damen-spalte spalte)
    (if (= spalte 0)
	leeres-brett
	(filter (lambda(damen) (unbedroht? (kopf damen) (rest damen)))
		(glattabb (lambda(l)
			    (abb (lambda(j) (cons-strom 
					     (cons-strom spalte j ) l))
				 (zeilen spalten)))
			  (damen-spalte (- spalte 1))   ))))
 
  (damen-spalte spalten))