;---------------------------------------------------------;
;                  Aufgabe 20                             ;
;---------------------------------------------------------;

;---------------------------------------------------------;
;                  Konstruktoren                          ;
;---------------------------------------------------------;
(define (konstr-summe a1 a2) (list '+ a1 a2))
(define (konstr-produkt a1 a2) (list '* a1 a2))

;---------------------------------------------------------;
;                  Selektoren                             ;
;---------------------------------------------------------;
(define (operand1 s) (cadr s))
(define (operand2 s) (caddr s))

;---------------------------------------------------------;
;                  Praedikate                             ;
;---------------------------------------------------------;
(define (konstante? x) (number? x))
(define (variable? x) (symbol? x))
(define (summe?   x) (if (pair? x) (eq? (car x) '+) #f))
(define (produkt? x) (if (pair? x) (eq? (car x) '*) #f))
(define (gleiche-variable? v1 v2)
  (and (variable? v1) (variable? v2) (eq? v1 v2)))

;---------------------------------------------------------;
; Ableitung aus der Vorlesung                             ;
;---------------------------------------------------------;	 
(define (ableitung a v)
  (cond ((konstante? a)  0)
	((variable? a) (if (gleiche-variable? a v) 1 0))
	((summe? a) (konstr-summe 
		     (ableitung (operand1 a) v)
		     (ableitung (operand2 a) v)))
	((produkt? a)
	 (konstr-summe
	  (konstr-produkt (operand1 a)
			  (ableitung (operand2 a) v))
	  (konstr-produkt (operand2 a)
			  (ableitung (operand1 a) v))))))

;---------------------------------------------------------;
;   Teil i)                                               ;
;---------------------------------------------------------;	 
;   Konstruktoren                                         ;
;---------------------------------------------------------;

(define (konstr-cos argument) (list 'cos argument))
(define (konstr-sin argument) (list 'sin argument))


;---------------------------------------------------------;
;   Praedikate                                            ;
;---------------------------------------------------------;
(define (cos? term) 
  (if (pair? term) (eq? (car term) 'cos) #f))
(define (sin? term) 
  (if (pair? term) (eq? (car term) 'sin) #f))

;---------------------------------------------------------;
; Teil ii)                                                ;
;---------------------------------------------------------;	 
(define (ableitung a v)
  (cond ((konstante? a)  0)
	((variable? a) (if (gleiche-variable? a v) 1 0))
	((summe? a) (konstr-summe 
		     (ableitung (operand1 a) v)
		     (ableitung (operand2 a) v)))
	((produkt? a)
	 (konstr-summe
	  (konstr-produkt (operand1 a)
			  (ableitung (operand2 a) v))
	  (konstr-produkt (operand2 a)
			  (ableitung (operand1 a) v))))
	((sin? a) (konstr-produkt (konstr-cos (operand1 a))
				  (ableitung (operand1 a) v)))
	((cos? a) (konstr-produkt -1
				  (konstr-produkt (konstr-sin (operand1 a))
						  (ableitung (operand1 a) v))))))

;---------------------------------------------------------;
; Teil iii)                                               ;
;---------------------------------------------------------;	 
(define f '(+ (* (sin x) (sin x)) (* (cos x) (cos x))))

; > (ableitung f 'x)
; (list '+
;       (list '+
;             (list '*
;                   (list 'sin 'x)
;                   (list '* -1 (list '* (list 'cos 'x) 1)))
;             (list '*
;                   (list 'sin 'x)
;                   (list '* -1 (list '* (list 'cos 'x) 1))))
;       (list '+
;             (list '*
;                   (list 'cos 'x)
;                   (list '* (list 'sin 'x) 1))
;             (list '*
;                   (list 'cos 'x)
;                  (list '* (list 'sin 'x) 1)))) 

;-------------------------------------------------------------;
;   Aufgabe 21,                                               ;
;-------------------------------------------------------------;
(define (vereinigungs-menge m1 m2)
  (cond ((null? m1) m2)
	((null? m2) m1)
	((eq? (car m1) (car m2)) (vereinigungs-menge (cdr m1) m2))
	((< (car m1) (car m2)) (cons (car m1)
				     (vereinigungs-menge (cdr m1) m2)))
	((> (car m1) (car m2)) (cons (car m2)
				     (vereinigungs-menge m1 (cdr m2))))))
	 
;-------------------------------------------------------------;
;   Aufgabe 22,   Prozeduren aus der Vorlesung                ;
;-------------------------------------------------------------;
;   Konstruktoren                                             ;
;-------------------------------------------------------------;
(define (konstr-baum e l r) (list e l r))

;-------------------------------------------------------------;
;   Selektoren                                                ;
;-------------------------------------------------------------;
(define (eintrag b) ( car b))
(define (linker-ast b) (cadr b))
(define (rechter-ast b) (caddr b))

;-------------------------------------------------------------;
;   Praedikate                                                ;
;-------------------------------------------------------------;
(define (element? x m)
  (if (null? m)
      #f
      (let ((e (eintrag m)))
        (cond ((= x e) #t)
              ((< x e) (element? x (linker-ast m)))
              (else (element? x (rechter-ast m)))))))

;-------------------------------------------------------------;
(define (hinzufuegen x m)
  (if (null? m) (konstr-baum x  '() '())
      (let ((e (eintrag m)))
        (cond ((= x e) m)
              ((< x e) (konstr-baum e 
                                    (hinzufuegen x (linker-ast m))
                                    (rechter-ast m)))
              (else (konstr-baum e
                                 (linker-ast m)
                                 (hinzufuegen x (rechter-ast m))))))))
;-------------------------------------------------------------;
;   Teil i)                                                   ;
;-------------------------------------------------------------;
(define (liste-nach-baum l)
  (cond ((null? l) '())
	(else (hinzufuegen (car l) (liste-nach-baum (cdr l))))))
;-----------------------------------------------------------------------;
; Teil ii)                                                              ;
;-----------------------------------------------------------------------;
(define (vereinigung m1 m2)
  (if (null? m1) 
      m2
     (vereinigung (linker-ast m1)
		  (vereinigung (rechter-ast m1) 
			       (hinzufuegen (eintrag m1)
					    m2)))))
;-----------------------------------------------------------------------;
; Teil iii)                                                             ;
;-----------------------------------------------------------------------;
(define (durchschnitt menge1 menge2)
  (cond ((or (null? menge1) (null? menge2)) '())
	((element? (eintrag menge1) menge2)
	 (konstr-baum (eintrag menge1)
		      (durchschnitt (linker-ast menge1) menge2)
		      (durchschnitt (rechter-ast menge1) menge2)))
	(else (vereinigung (durchschnitt (linker-ast menge1) menge2)
			   (durchschnitt (rechter-ast menge1) menge2)))))

;---------------------------------------------------------;
;                  Aufgabe 23                             ;
;---------------------------------------------------------;

;---------------------------------------------------------;
;                  Konstruktoren                          ;
;---------------------------------------------------------;

(define (konstr-blatt symbol wichtung)
  (list 'blatt symbol wichtung))

(define (konstr-code-baum links rechts)
  (list links 
	rechts
	(append (symbole links) (symbole rechts))
	(+ (wichtung links) (wichtung rechts))))

;---------------------------------------------------------;
;                  Selektoren                             ;
;---------------------------------------------------------;

(define (symbol-blatt x) (cadr x))

(define (wichtung-blatt x) (caddr x))

(define (linker-ast baum) (car baum))
(define (rechter-ast baum) (cadr baum))

(define (symbole baum)
  (if (blatt? baum)
      (list (symbol-blatt baum))
      (caddr baum)))

(define (wichtung baum)
  (if (blatt? baum)
      (wichtung-blatt baum)
      (cadddr baum)))

;---------------------------------------------------------;
;                  Praedikate                             ;
;---------------------------------------------------------;

(define (blatt? objekt)
  (eq? (car objekt) 'blatt))


;---------------------------------------------------------;
(define (hinzufuegen-menge x menge)
  (cond ((null? menge) (list x))
	((< (wichtung x) (wichtung (car menge)))
	 (cons x menge))
	(else (cons (car  menge)
		    (hinzufuegen-menge x (cdr menge))))))

(define (decodiere bits baum)
  (decodiere-1 bits baum baum))

(define (decodiere-1 bits baum aktueller-ast)
  (if (null? bits)
      '()
      (let ((naechster-ast
	     (waehle-ast (car bits)
			 aktueller-ast)))
	(if (blatt? naechster-ast)
	    (cons (symbol-blatt naechster-ast)
		  (decodiere-1 (cdr bits)
			       baum
			       baum))
	    (decodiere-1 (cdr bits)
			 baum
			 naechster-ast)))))

(define (waehle-ast bit ast)
  (cond ((= bit 0) (linker-ast ast))
	((= bit 1) (rechter-ast ast))
	(else (error "Falsches Bit -- WAEHLE-AST"))))


(define (konstr-blatt-menge paare)
  (if (null? paare)
      '()
      (let ((paar (car paare)))
	(hinzufuegen-menge
	 (konstr-blatt (car paar)
		       (cadr paar))
	 (konstr-blatt-menge (cdr paare))))))

(define (codiere nachricht baum)
  (if (null? nachricht)
      '()
      (append (codiere-symbol (car nachricht) baum)
	      (codiere (cdr nachricht) baum))))

(define (generiere-huffmann-baum paare)
  (nacheinander-vereinen (konstr-blatt-menge paare)))

;-----------------------------------------------------------------------;
; Teil i)                                                               ;
;-----------------------------------------------------------------------;
(define (codiere-symbol symbol baum)
  (cond ((not (member symbol (symbole baum)))
	 (error "Bustabe im Baum nicht vorhanden"))
        ((blatt? baum) '())
	((member symbol (symbole (linker-ast baum)))
	 (cons 0 (codiere-symbol symbol (linker-ast baum))))
	(else
	 (cons 1 (codiere-symbol symbol (rechter-ast baum))))))
;-----------------------------------------------------------------------;
; Teil ii)                                                               ;
;-----------------------------------------------------------------------;

(define (nacheinander-vereinen l)
  (if (null? (cdr l))
      (car l)
      (nacheinander-vereinen
       (hinzufuegen-menge
	(konstr-code-baum (car l) ( cadr l))
	(cddr l)))))
